﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace AndroidStarter
{
    public partial class Form1 : Form
    {
        String CFfile;
        int timer=0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            String dir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            StreamReader sr = new StreamReader(dir+"\\startup.txt");
            char[] buffer=new char[sr.BaseStream.Length];
            sr.Read(buffer, 0,(int)sr.BaseStream.Length);
            sr.Close();
            ConTB.Text = new string(buffer);
            ///
            int idx = -1;
            string key;
            ////resol
            key = "g900fb.lowres=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            bool err_ass = false;
            if (idx > key.Length)
            {
                if (ConTB.Text[idx] == '0')
                {
                    ResRad1.Checked = true;
                    ResRad2.Checked = false;
                }
                else
                {
                    ResRad1.Checked = false;
                    ResRad2.Checked = true;
                }
            } else {err_ass=true;}
            ///cpu
            key = "cpufreq-pxa2xx.pxa27x_maxfreq=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                CPUUpDown1.Text = ConTB.Text.Substring(idx, 3);
               
            }else {err_ass=true;}
            ///db
            key = "g900fb.buffers=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {    
                    checkDB.Checked=(ConTB.Text[idx] == '2');

            }else {err_ass=true;}
            ///power
            key = "g900_pwr_btn.noreset=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                chNoBtnReset.Checked = (ConTB.Text[idx] == '0');

            }else {err_ass=true;}
            //autostart
            key = "#autostart=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                domAutoStart.Text = ConTB.Text.Substring(idx, 1);
                timer =int.Parse( domAutoStart.Text);
            }else {err_ass=true;}
            if (err_ass) {}
            ///
            StreamWriter sw = new StreamWriter(dir + "\\startup.txt");
            sw.Write(ConTB.Text.ToCharArray());
            sw.Close();
           // ms.WriteTo(sw);
            
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            if (timer==0)
            {//save//
                String dir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
                Savebutton_Click(sender, e);
                ///start
                if (ResRad1.Checked)
                {
                    System.Diagnostics.Process MyProc = new System.Diagnostics.Process();
                    MyProc.StartInfo.FileName = dir + "\\gf_fix.exe";
                    MyProc.StartInfo.Arguments = "/start:0x2000000 /res:800x480";
                    MyProc.Start();
                }
                else
                {
                    System.Diagnostics.Process MyProc = new System.Diagnostics.Process();
                    MyProc.StartInfo.FileName = dir + "\\gf_fix.exe";
                    MyProc.StartInfo.Arguments = "/start:0x2000000 /res:400x240";
                    MyProc.Start();
                }

            }
            else
            {//timerstop
                timer = 0;
                buttonStart.Text = "Start";
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (timer > 0)
            {
                buttonStart.Text = timer.ToString() + " ... Cancel";
                timer--;
                if (timer == 0) { 
                    buttonStart.Text = "Starting..";
                    buttonStart_Click(sender, e);
                }
            }

        }

        private void Savebutton_Click(object sender, EventArgs e)
        {
            String dir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            StreamReader sr = new StreamReader(dir + "\\startup.txt");
            char[] buffer = new char[sr.BaseStream.Length];
            sr.Read(buffer, 0, (int)sr.BaseStream.Length);
            sr.Close();
            ConTB.Text = new string(buffer);
            ///
            int idx = -1;
            string key;
            ////resol
            key = "g900fb.lowres=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                if (ResRad1.Checked == true)
                {
                    buffer[idx] = '0';
                }
                else
                {
                    buffer[idx] = '1';
                }
            }
            ///cpu
            key = "cpufreq-pxa2xx.pxa27x_maxfreq=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                buffer[idx] = CPUUpDown1.Text[0];
                buffer[idx + 1] = CPUUpDown1.Text[1];
                buffer[idx + 2] = CPUUpDown1.Text[2];
            }
            ///db
            key = "g900fb.buffers=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                buffer[idx] = checkDB.Checked ? '2' : '1';
            }
            ///power
            key = "g900_pwr_btn.noreset=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                buffer[idx] = chNoBtnReset.Checked ? '0' : '1';
            }
            //autostart
            key = "#autostart=";
            idx = ConTB.Text.IndexOf(key) + key.Length;
            if (idx > key.Length)
            {
                buffer[idx] = domAutoStart.Text[0];

            }
            StreamWriter sw = new StreamWriter(dir + "\\startup.txt");
            sw.Write(buffer);
            sw.Close();
        }
    }
}